// Copyright (c) 2018 WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
//
// WSO2 Inc. licenses this file to you under the Apache License,
// Version 2.0 (the "License"); you may not use this file except
// in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.

import ballerina/io;
import ballerina/http;

@final string REMOTE_BACKEND_URL = "ws://localhost:15500/websocket";

endpoint http:Listener ep {
    port:9090
};

service<http:Service> proxy bind ep {

    @http:ResourceConfig {
        webSocketUpgrade:{
            upgradePath:"/ws"
        }
    }
    websocketProxy(endpoint httpEp, http:Request req) {
    }

    @http:ResourceConfig {
        methods:["GET"],
        path:"/hello"
    }
    sayHello(endpoint conn, http:Request req) {
        http:Response res = new;
        res.setTextPayload("Successful");
        _ = conn -> respond(res);
    }


    sayHi(endpoint conn, http:Request req) {
        http:Response res = new;
        res.setTextPayload("Successful");
        _ = conn -> respond(res);
    }
}